!function () {
  function bindReady (fn, win) {
    win = win || window;
    var done = false,
      top = true,
      doc = win.document,
      root = doc.documentElement,
      modern = doc.addEventListener,
      add = modern ? 'addEventListener' : 'attachEvent',
      rem = modern ? 'removeEventListener' : 'detachEvent',
      pre = modern ? '' : 'on',
      init = function (e) {
        if (e.type == 'readystatechange' && doc.readyState != 'complete') return;
        (e.type == 'load' ? win : doc)[rem](pre + e.type, init, false);
        if (!done && (done = true)) fn.call(win, e.type || e);
      },
      poll = function () {
        try {
          root.doScroll('left');
        } catch (e) {
          setTimeout(poll, 50);
          return;
        }
        init('poll');
      };

    if (doc.readyState == 'complete') fn.call(win, 'lazy');
    else {
      if (!modern && root.doScroll) {
        try {
          top = !win.frameElement;
        } catch (e) {
          info(e);
        }
        if (top) poll();
      }
      doc[add](pre + 'DOMContentLoaded', init, false);
      doc[add](pre + 'readystatechange', init, false);
      win[add](pre + 'load', init, false);
    }
  }
  function ry (dom) {
    return new ry.init(dom);
  }
  ry.init = function (dom) {
    this.ele = dom;
  };
  ry.init.prototype = {
    addClass: function (para) {
      var classes = ' ' + this.ele.className + ' ';
      if (classes.indexOf(' ' + para + ' ') === -1) {
        this.ele.className = this.ele.className + (this.ele.className === '' ? '' : ' ') + para;
      }
      return this;
    },
    removeClass: function (para) {
      var classes = ' ' + this.ele.className + ' ';
      if (classes.indexOf(' ' + para + ' ') !== -1) {
        this.ele.className = classes.replace(' ' + para + ' ', ' ').slice(1, -1);
      }
      return this;
    },
    hasClass: function (para) {
      var classes = ' ' + this.ele.className + ' ';
      if (classes.indexOf(' ' + para + ' ') !== -1) {
        return true;
      } else {
        return false;
      }
    },
    attr: function (key, value) {
      if (typeof key === 'string' && isUndefined(value)) {
        return this.ele.getAttribute(key);
      }
      if (typeof key === 'string') {
        value = String(value);
        this.ele.setAttribute(key, value);
      }
      return this;
    },
    offset: function () {
      var rect = this.ele.getBoundingClientRect();
      if (rect.width || rect.height) {
        var doc = this.ele.ownerDocument;
        var docElem = doc.documentElement;

        return {
          top: rect.top + window.pageYOffset - docElem.clientTop,
          left: rect.left + window.pageXOffset - docElem.clientLeft
        };
      } else {
        return {
          top: 0,
          left: 0
        };
      }
    },
    getSize: function () {
      if (!window.getComputedStyle) {
        return {
          width: this.ele.offsetWidth,
          height: this.ele.offsetHeight
        };
      }
      try {
        var bounds = this.ele.getBoundingClientRect();
        return {
          width: bounds.width,
          height: bounds.height
        };
      } catch (e) {
        return {
          width: 0,
          height: 0
        };
      }
    },
    getStyle: function (value) {
      if (this.ele.currentStyle) {
        return this.ele.currentStyle[value];
      } else {
        return this.ele.ownerDocument.defaultView.getComputedStyle(this.ele, null).getPropertyValue(value);
      }
    },
    wrap: function (elementTagName) {
      var ele = document.createElement(elementTagName);
      this.ele.parentNode.insertBefore(ele, this.ele);
      ele.appendChild(this.ele);
      return ry(ele);
    },
    getCssStyle: function (prop) {
      var result = this.ele.style.getPropertyValue(prop);
      if (result) {
        return result;
      }
      var rules = null;
      if (typeof window.getMatchedCSSRules === 'function') {
        rules = window.getMatchedCSSRules(this.ele);
      }
      if (!rules || !isArray(rules)) {
        return null;
      }
      for (var i = rules.length - 1; i >= 0; i--) {
        var r = rules[i];
        result = r.style.getPropertyValue(prop);
        if (result) {
          return result;
        }
      }
    },
    sibling: function (cur, dir) {
      while ((cur = cur[dir]) && cur.nodeType !== 1) { }
      return cur;
    },
    next: function () {
      return this.sibling(this.ele, 'nextSibling');
    },
    prev: function () {
      return this.sibling(this.ele, 'previousSibling');
    },
    siblings: function () {
      return this.siblings((this.ele.parentNode || {}).firstChild, this.ele);
    },
    children: function () {
      return this.siblings(this.ele.firstChild);
    },
    parent: function () {
      var parent = this.ele.parentNode;
      parent = parent && parent.nodeType !== 11 ? parent : null;
      return ry(parent);
    },
    previousElementSibling: function () {
      var el = this.ele;
      if ('previousElementSibling' in document.documentElement) {
        return ry(el.previousElementSibling);
      } else {
        while ((el = el.previousSibling)) {
          if (el.nodeType === 1) {
            return ry(el);
          }
        }
        return ry(null);
      }
    },
    nextElementSibling: function () {
      var el = this.ele;
      if ('nextElementSibling' in document.documentElement) {
        return ry(el.nextElementSibling);
      } else {
        while ((el = el.nextSibling)) {
          if (el.nodeType === 1) {
            return ry(el);
          }
        }
        return ry(null);
      }
    },
    getSameTypeSiblings: function () {
      var element = this.ele;
      var parentNode = element.parentNode;
      var tagName = element.tagName.toLowerCase();
      var arr = [];
      for (var i = 0; i < parentNode.children.length; i++) {
        var child = parentNode.children[i];
        if (child.nodeType === 1 && child.tagName.toLowerCase() === tagName) {
          arr.push(parentNode.children[i]);
        }
      }
      return arr;
    },
    getParents: function () {
      try {
        var element = this.ele;
        if (!isElement(element)) {
          return [];
        }
        var pathArr = [element];
        if (element === null || element.parentElement === null) {
          return [];
        }
        while (element.parentElement !== null) {
          element = element.parentElement;
          pathArr.push(element);
        }
        return pathArr;
      } catch (err) {
        return [];
      }
    }
  };
  function isElement (obj) {
    return !!(obj && obj.nodeType === 1);
  };
  function isObject (obj) {
    if (obj == null) {
      return false;
    } else {
      return toString.call(obj) == '[object Object]';
    }
  }
  function isFunction (f) {
    if (!f) {
      return false;
    }
    var type = toString.call(f);
    return type == '[object Function]' || type == '[object AsyncFunction]';
  }
  function info(logStr){
    console.log("SkyEyeLog: "+logStr);
  }
  // 处理URL发生变化时，做下一步处理；
  function urlChangeHandler () {
    try {
      // url发生变化的时候，跟app端请求拿历史埋点数据
      var current_url = decodeURIComponent(window.location.href);
      trackBaseTool.currentURL = current_url;
      info('url发生变化=== '+current_url);
      trackBaseTool.requestHistoryData({
        type: 6,
        data: {
        },
        url: current_url
      });
      setTimeout(() => {
        var eventList = handleEventList.pageViewEvents;
        info('handleEventList.pageViewEvents==', handleEventList.pageViewEvents);
        info("SkyEyeLog url change handler url: "+ current_url);
        eventList.forEach((item) => {
          let urlArr = item.page.split("##");
          let lastUrl = decodeURIComponent(urlArr[urlArr.length - 1]);
          info('lastUrl==', lastUrl);
          info('current_url==', current_url);
          // 判断item的url是否与当前的url相同，是的话，就上报事件；
          if (lastUrl === current_url && item.type === 4) {
            let reportObj = {
              type: 2,
              data: {
                eventName: item.eventName,
                $EventType$: 'PageImpression', // 事件类型：页面曝光事件
                timeStamp: new Date().getTime()
              }
            };
            // 上报事件给app
            info('上报页面浏览事件===', reportObj);
            // 上报页面浏览事件
            trackBaseTool.postData(reportObj);
          }
        });
      }, 1000);
    } catch (error) {
      info('urlChangeHandler error===, error');
    }

  }
  function fistRequestHistoryData () {
    // 首次加载的时候跟app端请求拿历史埋点数据
    trackBaseTool.requestHistoryData({
      type: 6,
      data: {
      },
      url: decodeURIComponent(window.location.href)
    });
  }
  // 处理路由变化监听
  function handleURLChange () {
    var historyPushState = window.history.pushState;
    var historyReplaceState = window.history.replaceState;

    // 重写window.history.pushState对象方法，使它在触发的时候上报url变化
    if (isFunction(window.history.pushState)) {
      window.history.pushState = function () {
        historyPushState.apply(window.history, arguments);
        info('pushState被触发了===', window.history);
        urlChangeHandler();
      };
    }
    // 重写window.history.replaceState对象方法，使它在触发的时候上报url变化
    if (isFunction(window.history.replaceState)) {
      window.history.replaceState = function () {
        historyReplaceState.apply(window.history, arguments);
        urlChangeHandler();
        info('replaceState被触发了===', window.history.replaceState);
        // postURL();
      };
    }

    var singlePageEvent;
    if (window.document.documentMode) {
      // IE模式下
      singlePageEvent = 'hashchange';
    } else {
      // 非IE模式下
      singlePageEvent = historyPushState ? 'popstate' : 'hashchange';
    }

    H5Event.addEventListener(window, singlePageEvent, function (e) {
      // postURL();
      info('singlePageEvent被触发了===', singlePageEvent);
      urlChangeHandler();
    });
  };
  // 添加事件监听&事件移除方法
  var H5Event = {
    // event:指定事件名；function:指定要事件触发时执行的函数;useCapture:指定事件是否在捕获或冒泡阶段执行。true - 事件句柄在捕获阶段执行,false- 默认。事件句柄在冒泡阶段执行
    // 注册添加事件监听
    addEventListener: function (event, myFunction, useCapture) {
      event.addEventListener ? event.addEventListener(myFunction, useCapture, false) : event.attachEvent ? event.attachEvent("on" + myFunction, useCapture) : event["on" + myFunction] = useCapture;
    },
    //移除事件监听
    removeEventListener: function (event, myFunction, useCapture) {
      event.removeEventListener ? event.removeEventListener(myFunction, useCapture, false) : event.detachEvent ? event.detachEvent("on" + myFunction, useCapture) : event["on" + myFunction] = useCapture;
    }
  };
  var trackBaseTool = {
    hashCode: null,
    currentURL: '',
    deepClone: function (source) {
      var target;
      if (typeof source === 'object') {
        target = Array.isArray(source) ? [] : {};
        for (var key in source) {
          if (source.hasOwnProperty(key)) {
            if (typeof source[key] !== 'object') {
              target[key] = source[key];
            } else {
              target[key] = this.deepClone(source[key]);
            }
          }
        }
      } else {
        target = source;
      }
      return target;
    },
    _decodeURI: function (val) {
      var result = val;
      try {
        result = decodeURI(val);
      } catch (e) {
        result = val;
      }
      return result;
    },
    urlParse: function (url) {
      var result = {};
      var domainName = '';
      var route = '';
      var param = '';
      var arrUrl = url.split('//');
      var protocal = arrUrl[0]; // 协议
      var start = arrUrl[1].indexOf('/');
      if (start > 0) {
        domainName = arrUrl[1].substring(0, start);
        var leftPart = arrUrl[1].substring(start); //stop省略，截取从start开始到结尾的所有字符
        if (leftPart.indexOf('?') != -1) {
          route = leftPart.split('?')[0];
          param = '?' + leftPart.split('?')[1]; //参数
        } else {
          route = leftPart; // 路径
        }
      } else {
        domainName = arrUrl[1];
      }
      result.page = decodeURIComponent(window.location.href);
      result.protocal = protocal;
      result.domainName = domainName;
      result.route = route;
      result.param = param;
      return result;
    },
    // 判断的元素的可见性；
    getVisibility: function (element) {
      if (!isElement(element)) {
        info('该元素不是element', element);
        return;
      }
      function isElementVisible (element) {
        var eleParentNode = element.parentNode;
        // nodeType=9 是document
        if (9 === eleParentNode.nodeType) return true;
        // 判断元素是否设置成不可见，如果设置成不可见，则返回false;
        if ("0" === getStyle(element, "opacity") || "none" === getStyle(element, "display") || "hidden" === getStyle(element, "visibility")) return false;
        if (eleParentNode) {
          //  getBoundingClientRect()获取元素位置，这个方法没有参数
          // getBoundingClientRect()用于获得页面中某个元素的左，上，右和下分别相对浏览器视窗的位置。
          // getBoundingClientRect()是DOM元素到浏览器可视范围的距离（不包含文档卷起的部分）。
          var eleParentNodeBound = eleParentNode.getBoundingClientRect();
          // 判断父节点有没有设置为隐藏或者滚动
          if ("hidden" === getStyle(eleParentNode, "overflow") || "scroll" === getStyle(eleParentNode, "overflow")) {
            // 当元素超出父节点元素上方|| 元素超出父节点元素下方 || 元素超出父节点元素左方 || 元素超出父节点元素右方, 此时元素不可见，返回false
            if (parseInt(elementBound.bottom) <= parseInt(eleParentNodeBound.top) || parseInt(elementBound.top) >= parseInt(eleParentNodeBound.bottom) || parseInt(elementBound.right) <= parseInt(eleParentNodeBound.left) || parseInt(elementBound.left) >= parseInt(eleParentNodeBound.right)) {
              // info('element==', element);
              // info('eleParentNode==', eleleParentNodeement);
              // info('elementBound==', elementBound);
              // info('eleParentNodeBound==', eleParentNodeBound);
              return false;
            }
            // 判断父节点的overflow-y属性有没有设置成隐藏或者滚动
          } else if ("hidden" === getStyle(eleParentNode, "overflow-y") || "scroll" === getStyle(eleParentNode, "overflow-y")) {
            // 当元素超出父节点元素上方|| 元素超出父节点元素下方,返回false
            if (parseInt(elementBound.bottom) <= parseInt(eleParentNodeBound.top) || parseInt(elementBound.top) >= parseInt(eleParentNodeBound.bottom)) return false;
            // 判断父节点的overflow-x属性有没有设置成隐藏或者滚动
          } else if ("hidden" === getStyle(eleParentNode, "overflow-x") || "scroll" === getStyle(eleParentNode, "overflow-x")) {
            // 元素超出父节点元素左方 || 元素超出父节点元素右方, 此时元素不可见，返回false
            if (parseInt(elementBound.right) <= parseInt(eleParentNodeBound.left) || parseInt(elementBound.left) >= parseInt(eleParentNodeBound.right)) return false;
          }
          return isElementVisible(eleParentNode);
        }
        return true;
      }

      function getStyle (element, styleName) {
        return window.getComputedStyle ? document.defaultView.getComputedStyle(element, null)[styleName] : element.currentStyle ? element.currentStyle[styleName] : void 0;
      }

      function isInViewPort (element) {
        const viewWidth = window.innerWidth || document.documentElement.clientWidth;
        const viewHeight = window.innerHeight || document.documentElement.clientHeight;
        const {
          top,
          right,
          bottom,
          left,
        } = element.getBoundingClientRect();
        return (
          parseInt(top) >= 0 &&
          parseInt(left) >= 0 &&
          parseInt(right) <= parseInt(viewWidth) &&
          parseInt(bottom) <= parseInt(viewHeight)
        );
      }


      var elementBound = element.getBoundingClientRect();
      return isElementVisible(element) && isInViewPort(element);
    },
    getTargetElement: function (element, e) {
      var that = this;
      var target = element;
      if (typeof target !== 'object') {
        return null;
      }
      if (typeof target.tagName !== 'string') {
        return null;
      }
      var tagName = target.tagName.toLowerCase();
      if (tagName.toLowerCase() === 'body' || tagName.toLowerCase() === 'html') {
        return null;
      }
      if (!target || !target.parentNode || !target.parentNode.children) {
        return null;
      }

      var parent_ele = target.parentNode;

      if (tagName === 'a' || tagName === 'button' || tagName === 'input' || tagName === 'textarea') {
        return target;
      } else if (parent_ele.tagName.toLowerCase() === 'button' || parent_ele.tagName.toLowerCase() === 'a') {
        return parent_ele;
      } else if (tagName === 'div' || tagName === 'li' || tagName === 'img' || tagName === 'svg') {
        return target;
      }
      return null;
    },
    
    getXPath: function (elm) {
      try {
        var allNodes = document.getElementsByTagName('*');
        var segs = [];
        for (; elm && elm.nodeType === 1; elm = elm.parentNode) {
          if (elm.hasAttribute('id')) {
            let uniqueIdCount = 0;
            for (let n = 0; n < allNodes.length; n++) {
              if (allNodes[n].hasAttribute('id') && allNodes[n].id === elm.id)
                uniqueIdCount++;
              if (uniqueIdCount > 1) break;
            }
            if (uniqueIdCount === 1) {
              segs.unshift('//*[@id="' + elm.getAttribute('id') + '"]');
              return segs.join('/');
            } else {
              return false;
            }
          } else {
            let i = 1;
            for (let sib = elm.previousSibling; sib; sib = sib.previousSibling) {
              if (sib.localName === elm.localName) i++;
            }
            if (i === 1) {
              if (elm.nextElementSibling) {
                if (elm.nextElementSibling.localName !== elm.localName) {
                  segs.unshift(elm.localName.toLowerCase() + '[' + i + ']');
                } else {
                  segs.unshift(elm.localName.toLowerCase() + '[' + i + ']');
                }
              } else {
                segs.unshift(elm.localName.toLowerCase() + '[' + i + ']');
              }
            } else {
              segs.unshift(elm.localName.toLowerCase() + '[' + i + ']');
            }
          }
        }
        return segs.length ? '/' + segs.join('/') : null;
      } catch (err) {
        return null;
      }
    },
    getElmByXPath: function (xpath) {
      const pEl = document.evaluate(xpath, document, null, XPathResult.ANY_TYPE, null);
      const result = [];
      let dom = pEl.iterateNext();
      while (dom) {
        result.push(dom);
        dom = pEl.iterateNext();
      }
      return result;
    },
    // 获取元素大小
    getBoundingClientRect: function (elm) {
      var rect = elm.getBoundingClientRect();
      var { left, top, right, bottom } = rect;
      var width = rect.width || right - left;
      var height = rect.height || bottom - top;
      var devicePixelRatio = window.devicePixelRatio; // 设备像素比
      // var screenHeight = window.screen.height; // 返回当前屏幕高度(空白空间)
      // var offsetHeight = window.document.body.offsetHeight;
      // var additonHeight = (screenHeight - offsetHeight) + top;
      return {
        width: (width * devicePixelRatio).toFixed(0),
        height: (height * devicePixelRatio).toFixed(0),
        left: (left * devicePixelRatio).toFixed(0),
        top: (top * devicePixelRatio).toFixed(0),
        bottom: (bottom * devicePixelRatio).toFixed(0),
        right: (right * devicePixelRatio).toFixed(0),
      };
    },
    trim: function (str) {
      return str.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, '');
    },
    // 获取元素标签内容
    getElementContent: function (target, tagName) {
      var textContent = '';
      var element_content = '';
      // if (target.textContent) {
      //   // 截取元素内容256字符以内；
      //   textContent = target.textContent.substring(0, 255);
      // } else if (target.innerText) {
      //   textContent = target.innerText.substring(0, 255);
      // }
      if (target.textContent) {
        textContent = trackBaseTool.trim(target.textContent);
      } else if (target.innerText) {
        textContent = trackBaseTool.trim(target.innerText);
      }
      if (textContent) {
        textContent = textContent
          .replace(/[\r\n]/g, ' ')
          .replace(/[ ]+/g, ' ')
          .substring(0, 100);
      }
      element_content = textContent || '';
      if (tagName === 'input' || tagName === 'INPUT' || tagName === 'textarea') {
        element_content = target.value || '';
      }
      return element_content;
    },
    // 获取同级标签位置
    getPosition: function (element) {
      var parentNode = element.parentNode;
      if (!parentNode) {
        return '';
      }
      var sameTypeSiblings = ry(element).getSameTypeSiblings();
      var typeLen = sameTypeSiblings.length;
      if (typeLen === 1) {
        return 1;
      }
      for (var i = 1, e = element; ry(e).previousElementSibling().ele; e = ry(e).previousElementSibling().ele, i++);
      return i;
    },
    getZIndex: function (element) {
      var zIndex = window.getComputedStyle(element, null).getPropertyValue("z-index");
      return zIndex && !isNaN(+zIndex) ? zIndex : 0;
    },
    getlevel: function (element, t) {
      var zIndex = Number(this.getZIndex(element));
      var i = 0;
      var positionValue = window.getComputedStyle(element, null).getPropertyValue("position");
      return !positionValue || "absolute" !== positionValue && "fixed" !== positionValue || (i = 1e5), t + zIndex + i;
    },
    // 是否有同级元素
    isHasSiblings: function (element) {
      var parentNode = element.parentNode;
      if (!parentNode) {
        return '';
      }
      var sameTypeSiblings = ry(element).getSameTypeSiblings();
      var typeLen = sameTypeSiblings.length;
      if (typeLen > 1) {
        return true;
      } else {
        return false;
      }
    },
    // 元素是否为叶子节点且有内容
    isLeafNode: function (element) {
      var isHasChildNodes = element.children.length > 0 ? true : false;
      var content = element.innerText || element.value; // 节点内容
      if (!isHasChildNodes && content) {
        return true;
      } else {
        return false;
      }
    },
    // 获取元素节点信息
    getElementInfo: function (element) {
      var tagName = element.tagName && element.tagName.toLocaleLowerCase() || ''; // 节点名称
      // var nodeName = element.nodeName && element.nodeName.toLocaleLowerCase() || ''; // 节点名称
      var content = this.getElementContent(element, tagName); // 节点内容
      var xpath = this.getXPath(element) || '';  // 获取元素xpath
      var xpathObj = this.xpathFormatter(xpath);
      // var position = this.getPosition(element) - 1; // 获取元素位置
      if (tagName === 'svg') {
        xpath = xpath.replace('/svg', "//*[name()='svg']");
      }
      var rect = this.getBoundingClientRect(element); // 获取元素大小
      var zIndex = Number(this.getZIndex(element)); // 元素的层叠顺序
      // var isHasSiblings = this.isHasSiblings(element); // 是否有同级元素
      // var scrollX = window.pageXOffset; // 返回文档/页面水平方向滚动的像素值。
      // var scrollY = window.pageYOffset; // 返回文档在垂直方向已滚动的像素值
      var eleData = {
        tagName: tagName, // 节点名称
        nodeType: tagName, // 节点名称
        xpath: this.encodeXpath(xpath), // 元素xpath
        index: xpathObj.lastNodeNum ? xpathObj.lastNodeNum - 3 : -1,// 元素位置
        zIndex: zIndex, // 元素的层叠顺序
        zLevel: element.level, // 元素的层叠顺序
        // isHasSiblings,
        content: content, // 节点内容
        // isShowContent: content ? true : false,
        // isShowPosition: position ? true : false,
        width: rect.width, // 节点宽度
        height: rect.height, // 节点高度
        left: rect.left, // 节点左侧边距
        top: rect.top, // 节点上侧边距
        // element_target_url: element.getAttribute('href'),
        url: decodeURIComponent(window.location.href), // 当前页面url
        title: document.title, // 文档title
        visibility: this.getVisibility(element),
      };
      return eleData;
    },
    getClickEleInfo: function (element, url) {
      var tagName = element.tagName && element.tagName.toLocaleLowerCase() || ''; // 节点名称
      // var nodeName = element.nodeName && element.nodeName.toLocaleLowerCase() || ''; // 节点名称
      var content = this.getElementContent(element, tagName); // 节点内容
      var xpath = this.getXPath(element) || '';  // 获取元素xpath
      // var position = this.getPosition(element) - 1; // 获取元素位置
      if (tagName === 'svg') {
        xpath = xpath.replace('/svg', "//*[name()='svg']");
      }
      var rect = this.getBoundingClientRect(element); // 获取元素大小
      var zIndex = Number(this.getZIndex(element)); // 元素的层叠顺序
      // var isHasSiblings = this.isHasSiblings(element); // 是否有同级元素
      // var scrollX = window.pageXOffset; // 返回文档/页面水平方向滚动的像素值。
      // var scrollY = window.pageYOffset; // 返回文档在垂直方向已滚动的像素值
      var page = url;
      var xpathObj = this.xpathFormatter(xpath);
      var elementEventMap = new Map();
      //rtype=0,无内容，无下标--> key：page+xpath[去最后节点下标]
      elementEventMap.set(page + xpathObj.xpathName, page + xpathObj.xpathName);
      //rtype=1,无内容，有下标--> key：page+xpath
      elementEventMap.set(page + xpath, page + xpath);
      //rtype=2,有内容，无下标--> key：page+xpath[去最后节点下标]+content
      elementEventMap.set(page + xpathObj.xpathName + content, page + xpathObj.xpathName + content);
      //rtype=3,有内容，有下标--> key：page+xpath+content
      elementEventMap.set(page + xpath + content, page + xpath + content);
      info('elementEventMap.size===', elementEventMap.size);

      var eleData = {
        tagName: tagName, // 节点名称
        nodeType: tagName, // 节点名称
        xpath: this.encodeXpath(xpath), // 元素xpath
        index: xpathObj.lastNodeNum ? xpathObj.lastNodeNum - 3 : -1,// 元素位置
        zIndex: zIndex, // 元素的层叠顺序
        zLevel: element.level, // 元素的层叠顺序
        // isHasSiblings,
        content: content, // 节点内容
        // isShowContent: content ? true : false,
        // isShowPosition: position ? true : false,
        width: rect.width, // 节点宽度
        height: rect.height, // 节点高度
        left: rect.left, // 节点左侧边距
        top: rect.top, // 节点上侧边距
        // element_target_url: element.getAttribute('href'),
        // url: decodeURIComponent(window.location.href), // 当前页面url
        url: url, // 当前页面url
        title: document.title, // 文档title
        elementEventMap: elementEventMap
      };
      return eleData;
    },
    throttle: function (fn, wait) {
      let timer = null;
      return function () {
        if (!timer) {
          // 函数fn放在定时器外且定时器初始化放在throttle函数外 是只执行第一次；
          // fn.apply(this, Array.prototype.slice.call(arguments, 0));
          timer = setTimeout(() => {
            // 函数fn放在定时器内且定时器初始化放在throttle函数内 是只执行最后一次
            fn.apply(this, Array.prototype.slice.call(arguments, 0));
            timer = null;
          }, wait);
        }
      };
    },
    
    // 添加DOM对象树监听，当DOM对象树发生任何变动时，发送元素相关信息；
    addDefineListener: function (fun) {
      function observeBody (element, options, callback) {
        // MutationObserver：Mutation Observer（变动观察器）是监视DOM变动的接口。当DOM对象树发生任何变动时，Mutation Observer会得到通知。
        var MutationObserver = window.MutationObserver || window.WebKitMutationObserver || window.MozMutationObserver;
        var mutation = new MutationObserver(callback);
        // observe(target, config)：target：需要监听的元素 [element], config：需要监听的属性 [Object] 例如 attributes \ childList等
        mutation.observe(element, options);
      };
      var _this = this;
      // MutationObserver所观察的DOM变动（即上面代码的option对象），包含以下类型：
      var options = {
        childList: true, // 子元素的变动
        subtree: true, // 属性的变动
        attributes: true // 所有下属节点（包括子节点和子节点的子节点）的变动
      };
      var handler = function () {
        return _this.throttle(fun, 2e3);
      }();
      observeBody(document.body, options, handler);
      H5Event.addEventListener(window, "scroll", handler);
      H5Event.addEventListener(window, "resize", handler);
      H5Event.addEventListener(window, "load", handler);
      // e.addSinglePageEvent(function (e) {
      //   e !== location.href && _this.postPageInfo();
      // });
    },
    // 循环遍历元素信息
    initElements: function () {
      var _this = this;
      var idIndex = 0;
      var result = [];
      var bodyChildren = [];
      bodyChildren = trackBaseTool.fileterInintElements(document.body.children);
      // info('bodyChildren count'+bodyChildren.length); 
      function n (element, level) {
        var i = {
          level: level,
          id: "h" + idIndex
        };
        idIndex++;
        element.sensorsDefineStore = i;
        // 目标元素筛选
        var targetElement = _this.getTargetElement(element);
        if (targetElement) {
          targetElement.sensorsdata_enable_click = true;
          var displayVlaue = window.getComputedStyle(targetElement, null).getPropertyValue("display");
          "inline" === displayVlaue && (targetElement.style.display = "inline-block");
        }
      }
      // 循环遍历元素节点
      function iterateSearch (eleChildren, r) {
        // info('eleChildren', eleChildren);
        // info('eleChildren.length', eleChildren.length);
        for (var i = 0; i < eleChildren.length; i++) {
          // info('eleChildren[i]', eleChildren[i].tagName);
          if (isElement(eleChildren[i])) {
            var element = eleChildren[i];
            var level = _this.getlevel(element, r);
            element.level = level;
            n(element, level);
            result.push(element);
            element.children && iterateSearch(element.children, level + 1);
          }
        }
      }
      return iterateSearch(bodyChildren, 1), result;
    },
    fileterInintElements: function (eleChildren) {
      var _this = this;
      var arr1 = [];
      var arr2 = [];
      var isModolExit = false;
      for (var i = 0; i < eleChildren.length; i++) {
        if (isElement(eleChildren[i])) {
          var element = eleChildren[i];
          var displayVlaue = window.getComputedStyle(element, null).getPropertyValue("display");
          var zIndex = Number(this.getZIndex(element));
          var positionValue = window.getComputedStyle(element, null).getPropertyValue("position");
          // var opacity = window.getComputedStyle(element, null).getPropertyValue("opacity");
          var left = window.getComputedStyle(element, null).getPropertyValue("left");
          var top = window.getComputedStyle(element, null).getPropertyValue("top");
          var bottom = window.getComputedStyle(element, null).getPropertyValue("bottom");
          var right = window.getComputedStyle(element, null).getPropertyValue("right");
          var width = window.getComputedStyle(element, null).getPropertyValue("width");
          var height = window.getComputedStyle(element, null).getPropertyValue("height");
          // element.displayVlaue = displayVlaue;
          element.zIndex = zIndex;
          element.positionValue = positionValue;
          // 判断是否存在遮罩层，遮罩层特点，1、position = absolute|| fixed；2、left =0 && top =0 || right=0 &&bottom =0；3、display !== none; 4、width!==0 && height!==0
          if ((positionValue === "absolute" || positionValue === "fixed")
            && ((left === '0px' && top === '0px') || (right === '0px' && bottom === '0px'))
            && displayVlaue !== 'none'
            && width !== '0px'
            && height !== '0px') {
            isModolExit = true;
          }
          if (positionValue === "absolute" || positionValue === "fixed") {
            arr1.push(element);
          } else {
            arr2.push(element);
          }
        }
      }
      //      info('isModolExit==', isModolExit);
      arr1 = arr1.sort(function (a, b) {
        return b.zIndex - a.zIndex;
      });
      // 如果存在遮罩层，取zInde最大值作为遍历初始起点
      if (arr1.length > 0 && isModolExit) {
        let resultArr = [];
        resultArr.push(arr1[0]);
        return resultArr;
      } else {
        return arr2;
      }
    },
    
    sortLevel: function (elementsArr) {
      return elementsArr.sort(function (a, b) {
        return a.zLevel - b.zLevel;
      }), elementsArr;
    },
    getDomInfo: function () {
      var _this = this;
      var enableClickElements = [];
      // var unalbeClickElements = [];

      var elementArr = trackBaseTool.initElements();
      // info('elementArr count: '+ elementArr.length);
      var enableClickElements = [];
      if (elementArr.length > 0) {
        elementArr.forEach(function (element) {
          if (isElement(element)) {
            var $element = element;
            var elementObj = _this.getElementInfo($element);
            // 判断元素对象是否可见
            if (isObject(elementObj) && elementObj.visibility) {
              // 判断元素是否为可点击的元素
              if ($element.sensorsdata_enable_click === true) {
                elementObj.enable_click = true;
                if (elementObj.tagName === 'li') {
                  elementObj.nodeType = 'LIST';
                } else if (elementObj.tagName === 'input' || elementObj.tagName === 'textarea') {
                  elementObj.nodeType = 'INPUT';
                } else {
                  elementObj.nodeType = 'BUTTON';
                }
                enableClickElements.push(elementObj);
              } else {
                elementObj.enable_click = false;
                if (_this.isLeafNode($element)) {
                  elementObj.nodeType = 'TEXT';
                  enableClickElements.push(elementObj);
                }
                // unalbeClickElements.push(elementObj);
              }
              //            }else {
              //               if (elementObj.tagName === 'li') {
              //                 info('不可见元素==', elementObj);
              //               }
            }

            // enableClickElements.push(elementObj);
          }
        });
      }
      return enableClickElements;
    },
    // 被动发送dom树结构信息对象
    responseDomInfo: function () {
      var enableClickElements = trackBaseTool.getDomInfo();
      var resultObj = {
        type: 1,
        data: {
          elements: trackBaseTool.sortLevel(enableClickElements),
          hashCode: trackBaseTool.hashCode
        }
      };
//      trackBaseTool.postData(resultObj);
        // var str = JSON.stringify(resultObj);
        // info("SkyEyeLog dom tree length : "+str.length);
        return resultObj;
    },
    hasAppBridge: function () {
      if (window.webkit && window.webkit.messageHandlers && window.webkit.messageHandlers.SKAPPnativeBridge && window.webkit.messageHandlers.SKAPPnativeBridge.postMessage) {
        return 'ios';
      } else if (isObject(window.JSBridge) && window.JSBridge.js_call_app) {
        return 'android';
      } else {
        info('App端bridge未暴露');
        return false;
      }
    },
    // js发送数据给app
    postData: function (appData) {
      // info('js发送数据给app==', appData);
      // 判断是否有IOS注册调用方法
      if (window.webkit && window.webkit.messageHandlers && window.webkit.messageHandlers.SKAPPnativeBridge && window.webkit.messageHandlers.SKAPPnativeBridge.postMessage) {
        window.webkit.messageHandlers.SKAPPnativeBridge.postMessage(JSON.stringify(appData));
        // 判断安卓是否有注册调用方法
      } else if (isObject(window.SkyEyeNative) && window.SkyEyeNative.sentToNative) {
        window.SkyEyeNative.sentToNative(JSON.stringify(appData));
      } else {
        info('数据发往App失败，App没有暴露bridge');
        return false;
      }
    },
    requestHistoryData: function (appData) {
      // 判断是否有IOS注册调用方法
      if (window.webkit && window.webkit.messageHandlers && window.webkit.messageHandlers.SKAPPnativeBridge && window.webkit.messageHandlers.SKAPPnativeBridge.postMessage) {
        let result = window.webkit.messageHandlers.SKAPPnativeBridge.postMessage(JSON.stringify(appData));
        handleEventList.init(result);
        // 判断安卓是否有注册调用方法
      } else if (isObject(window.SkyEyeNative) && window.SkyEyeNative.sentToNative) {
        try{
          let result = window.SkyEyeNative.sentToNative(JSON.stringify(appData));
          // info("requestHistoryData "+ JSON.stringify(result));
          let elemets = JSON.parse(result).elements;
          info("requestHistoryData "+ JSON.stringify(elemets));
          if(elemets){
            handleEventList.init(elemets);
          }
        }catch(error){
          info("获取当前页面埋点元素异常："+error);
        }
      } else {
        info('数据发往App失败，App没有暴露bridge');
        return false;
      }
    },
    // 添加DOM对象树监听，当DOM对象树发生任何变动时，发送元素相关信息；
    init: function () {
      var _this = this;
      trackBaseTool.currentURL = decodeURIComponent(window.location.href);
      window.app_h5_define_mode = function (isLoaded) {
        if (isLoaded) {
          // // 发送元素相关信息
        } else {
          bindReady(function () {
            // 发送元素相关信息
            // 添加DOM对象树监听，当DOM对象树发生任何变动时，发送元素相关信息；

            // 首次加载的时候，向app端发送请求，获取历史埋点信息
            // fistRequestHistoryData();
          });
        }
      };
    },
    // 定义JSBridge中app调用js的方法（JS接收app传来的数据）
    registerAppCallJs: function () {
      info("SkyEyeLog"+ "registerAppCallJs skyeye_app_call_js");
      // js 在全局window上声明一个函数供app调用
      window.skyeye_app_call_js = function (originalMessage) {
        // info('--native端 原始数据===', originalMessage);
        // 先把native的数据进行base64解码，然后decode, 再将字符串转json格式
        var start = new Date().getTime();
        try {
          // 将base64数据进行解码
          
          var atobData = atob(originalMessage);
          var decodeData = decodeURIComponent(atobData);
          var message = JSON.parse(decodeData);
        } catch (error) {
          info('native解码 error==', error);
        }
        //  info('SkyEyeLog --native端 解码数据 cost time:'+ (new Date().getTime() - start));

        // 对native端传来的数据，根据不同的type进行处理；
        let type = message.type || '';
        switch (type) {
          // type为1，传递编辑状态时，创建的埋点事件数据
          case 1:
            info('SkyEyeLog'+'传递编辑状态时，创建的埋点事件数据 type为1===');
            // trackBaseTool.handleUnvalidData(data);
            handleEventList.init(message.elements);
            break;
          // type为2，传递非编辑状态时，获取的历史埋点事件数据
          case 2:
            // 非编辑状态，需要h5 主动获取
            info('SkyEyeLog 传递非编辑状态时,埋点事件数据 type为2===');
            // handleEventList.init(message.elements);
            break;
          // type为3，app端主动获取dom树结构请求，js 将dom树通过 sentToNative 传递到客户端
          case 3:
            // info('message.hashCode===', message.hashCode);
            trackBaseTool.hashCode = message.hashCode || '';
            var ret = trackBaseTool.responseDomInfo();
            // info("SkyEyeLog responseDomInfo cost time: "+(new Date().getTime() - start));
            return ret;
          default:
            break;
        }
        return "";
      };
    },
    // xpath格式化处理函数
    xpathFormatter: function (str) {
      // debugger;
      if (!str) {
        return {
          lastNodeName: '', // xpath最后一个节点的名字[去掉下标]
          lastNodeNum: 0, // xpath最后一个节点下标的数字+1
          xpathName: '' // xpath最后一个节点路径（去掉最后的下标）
        };
      }
      let obj = {
        lastNodeName: '', // xpath最后一个节点的名字[去掉下标]
        lastNodeNum: 0, // xpath最后一个节点下标的数字+1
        xpathName: '' // xpath最后一个节点路径（去掉最后的下标）
      };
      // 将xpath中匹配【】的数字加1
      // let decodeStr = str.replace(/\[[0-9]\]/g, function (match) {
      //   return '[' + String(Number(match.substring(1, match.length - 1)) + 1) + ']';
      // });
      // info('str==', str);
      let decodeStr = this.decodeXpath(str);
      // info('decodeStr==', decodeStr);
      let strArr = decodeStr.split('/');
      let newData = '';
      let lastItem = strArr.length > 0 ? strArr.slice(-1) : '';
      let regResult = lastItem[0].match('/?([^\\[]+)(\\[[0-9-\\[\\]]+\\])?');
      // info('xpathFormatter regResult==', regResult);
      if (regResult.length < 3) {
        return;
      }
      obj.lastNodeName = regResult[1];
      if (regResult[2]) {
        obj.lastNodeNum =
          regResult[2] === '[-]'
            ? 0
            : Number(regResult[2].replace(/\[|]/g, '')) + 1;
      }
      strArr.map((item, index) => {
        if (item && index < strArr.length - 1) {
          if (newData) {
            newData = newData + '/' + item;
          } else {
            newData = '/' + item;
          }
        }
      });
      obj.xpathName = '/' + newData + '/' + obj.lastNodeName;
      return obj;
    },
    // xpath下标-1
    encodeXpath: function (str) {
      let encodeStr = str.replace(/\[[0-9]\]/g, function (match) {
        return '[' + String(Number(match.substring(1, match.length - 1)) - 1) + ']';
      });
      return encodeStr;
    },
    // xpath下标+1
    decodeXpath: function (str) {
      let decodeStr = str.replace(/\[[0-9]\]/g, function (match) {
        return '[' + String(Number(match.substring(1, match.length - 1)) + 1) + ']';
      });
      return decodeStr;
    }
  };

  var handleEventList = {
    // 事件
    initData: [], // 本页所有事件
    webClickEvents: [], // 网页点击事件
    webViewEvents: [],// 网页元素曝光事件
    pageViewEvents: [], // 页面浏览事件
    eventHandler: new Map(),
    bindWebMap: new Map(),
    isDomLoad: false,
    // 初始化
    init: function (data) {
      info("SkyEyeLog"+ " handleEventList init ");

      this.initData = data;
      let unbindData = trackBaseTool.deepClone(this.webClickEvents);
      setTimeout(()=>{
        info("SkyEyeLog"+ " unbindWebClickEvents ");
        this.unbindWebClickEvents(unbindData);
        info("SkyEyeLog"+ " filterWebClickEvents");
        this.filterWebClickEvents(data);
        
        try {
          var start = new Date().getTime();
          info("SkyEyeLog"+ " bindWebClickEvents");
          this.bindWebClickEvents(data);
          info("SkyEyeLog"+ " bindWebClickEvents cost time: "+ (new Date().getTime() - start));
        } catch (error) {
          info('bindWebClickEvents error==', error);
        }
      }, 500);

    },
    // 过滤网页点击事件与页面浏览事件
    filterWebClickEvents: function (allEventList) {
      this.webClickEvents = allEventList.filter((item) => {
        return item.type === 1 || item.type === 3;
      });
      this.webViewEvents = allEventList.filter((item) => {
        return item.type === 2 || item.type === 3;
      });
      this.pageViewEvents = allEventList.filter((item) => {
        return item.type === 4;
      });
      // info('网页点击事件 webClickEvents==', this.webClickEvents);
      // info('网页元素曝光事件 webViewEvents==', this.webViewEvents);
      // info('页面曝光事件 pageViewEvents==', this.pageViewEvents);
      // 筛选出网页点击事件
    },
    removeAllEventHanler () {
      for (var node in this.eventHandler) {
        window.removeEventListener('click', this.eventHandler[node]);
      }
    },
    // 从所有埋点事件中筛选出点击埋点事件，然后根据xpath从dom树中找元素，对元素的点击绑定监听，触发的时候上报事件；
    bindWebClickEvents: function (allEventList) {
      info("SkyEyeLog"+'对页面元素绑定点击事件====');
      var list = [...allEventList];
      list.forEach(item => {
        if (item.type === 1 || item.type === 3) {
          var rtype = item.rtype;
          let urlArr = item.page.split("##");
          let page = decodeURIComponent(urlArr[urlArr.length - 1]);
          let itemXpath = trackBaseTool.decodeXpath(item.xpath);
          var xpathObj = trackBaseTool.xpathFormatter(item.xpath);
          info('绑定点击事件 eventName==='+ item.eventName);
          info('rtype==='+ rtype);
          info('page==='+ page);
          info('trackBaseTool.currentURL==='+ trackBaseTool.currentURL);
          info('xpathObj.xpathName==='+ xpathObj.xpathName);
          switch (rtype) {
            case 0:
              //rtype=0,无内容，无下标--> key：page+xpath[去最后节点下标]
              if (page === trackBaseTool.currentURL) {
                let $element = trackBaseTool.getElmByXPath(xpathObj.xpathName);
                info('rtype=0 $element size ==='+ $element.length);
                if ($element.length > 0) {
                  $element.forEach(eleItem => {
                    let data = {
                      eventName: item.eventName,
                      $EventType$: 'ViewClick', // 事件类型：点击事件
                      timeStamp: new Date().getTime()
                    };
                    let bindProperties = item.bindProperties;
                    // info('bindProperties===', bindProperties);
                    if (bindProperties.length > 0) {
                      bindProperties.forEach((propertyItem) => {
                        let proItemXpath = trackBaseTool.decodeXpath(propertyItem.xpath);
                        let propertyEle = trackBaseTool.getElmByXPath(proItemXpath);
                        if (propertyEle[0]) {
                          var content = trackBaseTool.getElementContent(propertyEle[0], propertyEle[0].tagName);
                          data[propertyItem.attributeKey] = content;
                          data[propertyItem.attributeKey + '.$propertyshowname$'] = propertyItem.attributeKeyName;
                        }
                      });
                    }
                    try {
                      // if (handleEventList.eventHandler.has(page + xpathObj.xpathName)) {
                      //   info('移除rtype=0监听事件===', item.eventName);
                      //   eleItem.removeEventListener("click", handleEventList.eventHandler.get(page + xpathObj.xpathName));
                      // }
                      handleEventList.eventHandler.set(page + xpathObj.xpathName, function () {
                        data.timeStamp = new Date().getTime();
                        info('SkyEyeLog'+'000 reportObj==='+ data);
                        if (window.webkit && window.webkit.messageHandlers && window.webkit.messageHandlers.SKAPPnativeBridge && window.webkit.messageHandlers.SKAPPnativeBridge.postMessage) {
                          window.webkit.messageHandlers.SKAPPnativeBridge.postMessage(JSON.stringify({
                            type: 2,
                            data: data
                          }));
                          // 判断安卓是否有注册调用方法
                        } else if (isObject(window.SkyEyeNative) && window.SkyEyeNative.sentToNative) {
                          window.SkyEyeNative.sentToNative(JSON.stringify({
                            type: 2,
                            data: data
                          }));
                        } else {
                          info('数据发往App失败，App没有暴露bridge');
                          return false;
                        }
                      });
                      // 给元素绑定上报事件
                      eleItem.addEventListener("click", handleEventList.eventHandler.get(page + xpathObj.xpathName));
                      info('SkyEyeLog addEventListener eventName==='+ item.eventName);
                    } catch (error) {
                      info('bindItemClickHandler0 err0r==', error);
                    }
                  });
                }
              }
              break;
            case 1:
              //rtype=1,无内容，有下标--> key：page+xpath
              // item.eleKey = page + item.xpath;
              if (page === trackBaseTool.currentURL) {
                let $element = trackBaseTool.getElmByXPath(itemXpath);
                // info('rtype=1 $element===', $element);
                // info('rtype=1 $element===', $element.length);
                // info('rtype=1 item.xpath===', item.xpath);
                // info('rtype=1 itemXpath===', itemXpath);
                if ($element.length > 0) {
                  $element.forEach(eleItem => {
                    let data = {
                      eventName: item.eventName,
                      $EventType$: 'ViewClick', // 事件类型：曝光事件
                      timeStamp: new Date().getTime()
                    };
                    let bindProperties = item.bindProperties;
                    // info('bindProperties===', bindProperties);
                    if (bindProperties.length > 0) {
                      bindProperties.forEach((propertyItem) => {
                        let proItemXpath = trackBaseTool.decodeXpath(propertyItem.xpath);
                        let propertyEle = trackBaseTool.getElmByXPath(proItemXpath);
                        if (propertyEle[0]) {
                          var content = trackBaseTool.getElementContent(propertyEle[0], propertyEle[0].tagName);
                          data[propertyItem.attributeKey] = content;
                          data[propertyItem.attributeKey + '.$propertyshowname$'] = propertyItem.attributeKeyName;
                        }
                      });
                    }
                    try {
                      // if (handleEventList.eventHandler.has(page + itemXpath)) {
                      //   info('移除rtype=1监听事件===', item.eventName);
                      //   eleItem.removeEventListener("click", handleEventList.eventHandler.get(page + itemXpath));
                      // }
                      // info('eventName===', item.eventName);
                      // info('eleItem===', eleItem.tagName);
                      // info('page===', page);
                      // info('itemXpath===', itemXpath);
                      handleEventList.eventHandler.set(page + itemXpath, function () {
                        data.timeStamp = new Date().getTime();
                        info('111 reportObj==='+ data);
                        if (window.webkit && window.webkit.messageHandlers && window.webkit.messageHandlers.SKAPPnativeBridge && window.webkit.messageHandlers.SKAPPnativeBridge.postMessage) {
                          window.webkit.messageHandlers.SKAPPnativeBridge.postMessage(JSON.stringify({
                            type: 2,
                            data: data
                          }));
                          // 判断安卓是否有注册调用方法
                        } else if (isObject(window.SkyEyeNative) && window.SkyEyeNative.sentToNative) {
                          window.SkyEyeNative.sentToNative(JSON.stringify({
                            type: 2,
                            data: data
                          }));
                        } else {
                          info('数据发往App失败，App没有暴露bridge');
                          return false;
                        }
                      });
                      // 给元素绑定上报事件
                      eleItem.addEventListener("click", handleEventList.eventHandler.get(page + itemXpath));
                      info('eventName===', item.eventName);
                    } catch (error) {
                      info('bindItemClickHandler0 err0r==', error);
                    }
                  });
                }
              }
              break;
            case 2:
              //rtype=2,有内容，无下标--> key：page+xpath[去最后节点下标]+content
              // item.eleKey = page + xpathObj.xpathName + item.content;
              if (page === trackBaseTool.currentURL) {
                let $element = trackBaseTool.getElmByXPath(xpathObj.xpathName);
                info('rtype=2 $element===', $element);
                if ($element.length > 0) {
                  $element.forEach(eleItem => {
                    let $eleContent = trackBaseTool.getElementContent(eleItem, eleItem.tagName);
                    // info('$eleContent===', $eleContent);
                    // info('item.content===', item.content);
                    if ($eleContent === item.content) {
                      // 元素内容相等
                      // info('元素内容相同===');
                      let data = {
                        eventName: item.eventName,
                        $EventType$: 'ViewClick', // 事件类型：点击事件
                        timeStamp: new Date().getTime()
                      };
                      let bindProperties = item.bindProperties;
                      // info('bindProperties===', bindProperties);
                      if (bindProperties.length > 0) {
                        bindProperties.forEach((propertyItem) => {
                          let proItemXpath = trackBaseTool.decodeXpath(propertyItem.xpath);
                          let propertyEle = trackBaseTool.getElmByXPath(proItemXpath);
                          if (propertyEle[0]) {
                            var content = trackBaseTool.getElementContent(propertyEle[0], propertyEle[0].tagName);
                            data[propertyItem.attributeKey] = content;
                            data[propertyItem.attributeKey + '.$propertyshowname$'] = propertyItem.attributeKeyName;
                          }
                        });
                      }
                      try {
                        // if (handleEventList.eventHandler.has(page + xpathObj.xpathName + item.content)) {
                        //   info('移除rtype=2监听事件===', item.eventName);
                        //   eleItem.removeEventListener("click", handleEventList.eventHandler.get(page + xpathObj.xpathName + item.content));
                        // }
                        handleEventList.eventHandler.set(page + xpathObj.xpathName + item.content, function () {
                          data.timeStamp = new Date().getTime();
                          info('222 reportObj===', data);
                          if (window.webkit && window.webkit.messageHandlers && window.webkit.messageHandlers.SKAPPnativeBridge && window.webkit.messageHandlers.SKAPPnativeBridge.postMessage) {
                            window.webkit.messageHandlers.SKAPPnativeBridge.postMessage(JSON.stringify({
                              type: 2,
                              data: data
                            }));
                            // 判断安卓是否有注册调用方法
                          } else if (isObject(window.SkyEyeNative) && window.SkyEyeNative.sentToNative) {
                            window.SkyEyeNative.sentToNative(JSON.stringify({
                              type: 2,
                              data: data
                            }));
                          } else {
                            info('数据发往App失败，App没有暴露bridge');
                            return false;
                          }
                        });
                        // 给元素绑定上报事件
                        eleItem.addEventListener("click", handleEventList.eventHandler.get(page + xpathObj.xpathName + item.content));
                        info('eventName===', item.eventName);
                      } catch (error) {
                        info('bindItemClickHandler2 err0r==', error);
                      }
                    }
                  });
                }
              }
              break;
            case 3:
              //rtype=3,有内容，有下标--> key：page+xpath+content
              // item.eleKey = page + itemXpath + item.content;
              if (page === trackBaseTool.currentURL) {
                let $element = trackBaseTool.getElmByXPath(itemXpath);
                info('rtype=3 $element===', $element);
                if ($element.length > 0) {
                  $element.forEach(eleItem => {
                    let $eleContent = trackBaseTool.getElementContent(eleItem, eleItem.tagName);
                    // info('$eleContent===', $eleContent);
                    // info('item.content===', item.content);
                    if ($eleContent === item.content) {
                      // 元素内容相等
                      info('元素内容相同===');
                      let data = {
                        eventName: item.eventName,
                        $EventType$: 'ViewClick', // 事件类型：点击事件
                        timeStamp: new Date().getTime()
                      };
                      let bindProperties = item.bindProperties;
                      // info('bindProperties===', bindProperties);
                      if (bindProperties.length > 0) {
                        bindProperties.forEach((propertyItem) => {
                          let proItemXpath = trackBaseTool.decodeXpath(propertyItem.xpath);
                          let propertyEle = trackBaseTool.getElmByXPath(proItemXpath);
                          if (propertyEle[0]) {
                            var content = trackBaseTool.getElementContent(propertyEle[0], propertyEle[0].tagName);
                            data[propertyItem.attributeKey] = content;
                            data[propertyItem.attributeKey + '.$propertyshowname$'] = propertyItem.attributeKeyName;
                          }
                        });
                      }
                      try {
                        // if (handleEventList.eventHandler.has(page + itemXpath + item.content)) {
                        //   info('移除rtype=3监听事件===', item.eventName);
                        //   eleItem.removeEventListener("click", handleEventList.eventHandler.get(page + itemXpath + item.content));
                        // }
                        handleEventList.eventHandler.set(page + itemXpath + item.content, function () {
                          data.timeStamp = new Date().getTime();
                          info('333 reportObj===', data);
                          if (window.webkit && window.webkit.messageHandlers && window.webkit.messageHandlers.SKAPPnativeBridge && window.webkit.messageHandlers.SKAPPnativeBridge.postMessage) {
                            window.webkit.messageHandlers.SKAPPnativeBridge.postMessage(JSON.stringify({
                              type: 2,
                              data: data
                            }));
                            // 判断安卓是否有注册调用方法
                          } else if (isObject(window.SkyEyeNative) && window.SkyEyeNative.sentToNative) {
                            window.SkyEyeNative.sentToNative(JSON.stringify({
                              type: 2,
                              data: data
                            }));
                          } else {
                            info('数据发往App失败，App没有暴露bridge');
                            return false;
                          }
                        });
                        // 给元素绑定上报事件
                        eleItem.addEventListener("click", handleEventList.eventHandler.get(page + itemXpath + item.content));
                        info('eventName===', item.eventName);
                      } catch (error) {
                        info('bindItemClickHandler0 err0r==', error);
                      }
                    }
                  });
                }
              }
              break;
            default:
              break;
          }
        };
      });
    },
    unbindWebClickEvents: function (allEventList) {
      info('解除已绑定元素事件');
      var list = [...allEventList];
      list.forEach(item => {
        if (item.type === 1 || item.type === 3) {
          var rtype = item.rtype;
          let urlArr = item.page.split("##");
          let page = decodeURIComponent(urlArr[urlArr.length - 1]);
          let itemXpath = trackBaseTool.decodeXpath(item.xpath);
          var xpathObj = trackBaseTool.xpathFormatter(item.xpath);
          switch (rtype) {
            case 0:
              //rtype=0,无内容，无下标--> key：page+xpath[去最后节点下标]
              if (page === trackBaseTool.currentURL) {
                let $element = trackBaseTool.getElmByXPath(xpathObj.xpathName);
                // info('$element===', $element);
                if ($element.length > 0) {
                  $element.forEach(eleItem => {
                    let data = {
                      eventName: item.eventName,
                      $EventType$: 'ViewClick', // 事件类型：点击事件
                      timeStamp: new Date().getTime()
                    };
                    let bindProperties = item.bindProperties;
                    // info('bindProperties===', bindProperties);
                    if (bindProperties.length > 0) {
                      bindProperties.forEach((propertyItem) => {
                        let proItemXpath = trackBaseTool.decodeXpath(propertyItem.xpath);
                        let propertyEle = trackBaseTool.getElmByXPath(proItemXpath);
                        if (propertyEle[0]) {
                          var content = trackBaseTool.getElementContent(propertyEle[0], propertyEle[0].tagName);
                          data[propertyItem.attributeKey] = content;
                          data[propertyItem.attributeKey + '.$propertyshowname$'] = propertyItem.attributeKeyName;
                        }
                      });
                    }
                    try {
                      if (handleEventList.eventHandler.has(page + xpathObj.xpathName)) {
                        info('unbindWebClickEvents 移除rtype=0监听事件===', item.eventName);
                        eleItem.removeEventListener("click", handleEventList.eventHandler.get(page + xpathObj.xpathName));
                      }
                    } catch (error) {
                      info('bindItemClickHandler0 err0r==', error);
                    }
                  });
                }
              }
              break;
            case 1:
              //rtype=1,无内容，有下标--> key：page+xpath
              // item.eleKey = page + item.xpath;
              if (page === trackBaseTool.currentURL) {
                let $element = trackBaseTool.getElmByXPath(itemXpath);
                if ($element.length > 0) {
                  $element.forEach(eleItem => {
                    let data = {
                      eventName: item.eventName,
                      $EventType$: 'ViewClick', // 事件类型：曝光事件
                      timeStamp: new Date().getTime()
                    };
                    let bindProperties = item.bindProperties;
                    // info('bindProperties===', bindProperties);
                    if (bindProperties.length > 0) {
                      bindProperties.forEach((propertyItem) => {
                        let proItemXpath = trackBaseTool.decodeXpath(propertyItem.xpath);
                        let propertyEle = trackBaseTool.getElmByXPath(proItemXpath);
                        if (propertyEle[0]) {
                          var content = trackBaseTool.getElementContent(propertyEle[0], propertyEle[0].tagName);
                          data[propertyItem.attributeKey] = content;
                          data[propertyItem.attributeKey + '.$propertyshowname$'] = propertyItem.attributeKeyName;
                        }
                      });
                    }
                    try {
                      if (handleEventList.eventHandler.has(page + itemXpath)) {
                        info('unbindWebClickEvents 移除rtype=1监听事件===', item.eventName);
                        eleItem.removeEventListener("click", handleEventList.eventHandler.get(page + itemXpath));
                      }
                    } catch (error) {
                      info('bindItemClickHandler0 err0r==', error);
                    }
                  });
                }
              }
              break;
            case 2:
              //rtype=2,有内容，无下标--> key：page+xpath[去最后节点下标]+content
              // item.eleKey = page + xpathObj.xpathName + item.content;
              if (page === trackBaseTool.currentURL) {
                let $element = trackBaseTool.getElmByXPath(xpathObj.xpathName);
                // info('$element===', $element);
                if ($element.length > 0) {
                  $element.forEach(eleItem => {
                    let $eleContent = trackBaseTool.getElementContent(eleItem, eleItem.tagName);
                    // info('$eleContent===', $eleContent);
                    // info('item.content===', item.content);
                    if ($eleContent === item.content) {
                      // 元素内容相等
                      // info('元素内容相同===');
                      let data = {
                        eventName: item.eventName,
                        $EventType$: 'ViewClick', // 事件类型：点击事件
                        timeStamp: new Date().getTime()
                      };
                      let bindProperties = item.bindProperties;
                      // info('bindProperties===', bindProperties);
                      if (bindProperties.length > 0) {
                        bindProperties.forEach((propertyItem) => {
                          let proItemXpath = trackBaseTool.decodeXpath(propertyItem.xpath);
                          let propertyEle = trackBaseTool.getElmByXPath(proItemXpath);
                          if (propertyEle[0]) {
                            var content = trackBaseTool.getElementContent(propertyEle[0], propertyEle[0].tagName);
                            data[propertyItem.attributeKey] = content;
                            data[propertyItem.attributeKey + '.$propertyshowname$'] = propertyItem.attributeKeyName;
                          }
                        });
                      }
                      try {
                        if (handleEventList.eventHandler.has(page + xpathObj.xpathName + item.content)) {
                          info('unbindWebClickEvents 移除rtype=2监听事件===', item.eventName);
                          eleItem.removeEventListener("click", handleEventList.eventHandler.get(page + xpathObj.xpathName + item.content));
                        }
                      } catch (error) {
                        info('bindItemClickHandler0 err0r==', error);
                      }
                    }
                  });
                }
              }
              break;
            case 3:
              //rtype=3,有内容，有下标--> key：page+xpath+content
              // item.eleKey = page + itemXpath + item.content;
              if (page === trackBaseTool.currentURL) {
                let $element = trackBaseTool.getElmByXPath(itemXpath);
                if ($element.length > 0) {
                  $element.forEach(eleItem => {
                    let $eleContent = trackBaseTool.getElementContent(eleItem, eleItem.tagName);
                    // info('$eleContent===', $eleContent);
                    // info('item.content===', item.content);
                    if ($eleContent === item.content) {
                      // 元素内容相等
                      // info('元素内容相同===');
                      let data = {
                        eventName: item.eventName,
                        $EventType$: 'ViewClick', // 事件类型：点击事件
                        timeStamp: new Date().getTime()
                      };
                      let bindProperties = item.bindProperties;
                      // info('bindProperties===', bindProperties);
                      if (bindProperties.length > 0) {
                        bindProperties.forEach((propertyItem) => {
                          let proItemXpath = trackBaseTool.decodeXpath(propertyItem.xpath);
                          let propertyEle = trackBaseTool.getElmByXPath(proItemXpath);
                          if (propertyEle[0]) {
                            var content = trackBaseTool.getElementContent(propertyEle[0], propertyEle[0].tagName);
                            data[propertyItem.attributeKey] = content;
                            data[propertyItem.attributeKey + '.$propertyshowname$'] = propertyItem.attributeKeyName;
                          }
                        });
                      }
                      try {
                        if (handleEventList.eventHandler.has(page + itemXpath + item.content)) {
                          info('unbindWebClickEvents 移除rtype=3监听事件===', item.eventName);
                          eleItem.removeEventListener("click", handleEventList.eventHandler.get(page + itemXpath + item.content));
                        }
                      } catch (error) {
                        info('bindItemClickHandler0 err0r==', error);
                      }
                    }
                  });
                }
              }
              break;
            default:
              break;
          }
        };
      });
    },
    // 判断是否为目标元素
    isTargetEle: function (elementInfo) {
      // info('监听的点击元素信息elementInfo==', elementInfo);
      let elementEventMap = elementInfo.elementEventMap;
      // info('elementEventMap.size===', elementEventMap.size);
      // 传参进来目标元素，然后与历史埋点点击事件做匹配，看是否为埋点事件，是的返回true,不是的话返回false
      if (elementEventMap.size > 0) {
        for (let key of elementEventMap.keys()) {
          // info('handleEventList.bindWebMap.size', handleEventList.bindWebMap.size);
          // info('elementEventMap key==', key);
          // info('handleEventList.bindWebMap.has(key)', handleEventList.bindWebMap.has(key));
          // for (let item of handleEventList.bindWebMap.keys()) {
          //   info('bindWebMap key==', item);
          // }
          if (handleEventList.bindWebMap.has(key)) {
            // info('该数据为已埋点对象', key);
            let bindItem = handleEventList.bindWebMap.get(key);
            // info('bindItem', bindItem);
            // let mkvObj = {};
            let data = {
              eventName: bindItem.eventName,
              $EventType$: 'ViewClick', // 事件类型：点击事件
              timeStamp: new Date().getTime()
            };
            let bindProperties = bindItem.bindProperties;
            if (bindProperties.length > 0) {
              bindProperties.forEach((propertyItem) => {
                let proItemXpath = trackBaseTool.decodeXpath(propertyItem.xpath);
                let propertyEle = trackBaseTool.getElmByXPath(proItemXpath);
                if (propertyEle[0]) {
                  var content = trackBaseTool.getElementContent(propertyEle[0], propertyEle[0].tagName);
                  data[propertyItem.attributeKey] = content;
                  data[propertyItem.attributeKey + '.$propertyshowname$'] = propertyItem.attributeKeyName;
                }
              });
              // 埋点上报
              let reportObj = {
                type: 3,
                data: data
              };
              info('reportObj==', reportObj);
              trackBaseTool.postData(reportObj);
              // SKAPP.onEvent(bindItem.eventName, '', mkvObj);
            } else {
              // 埋点上报
              let reportObj = {
                type: 3,
                data: data
              };
              info('reportObj==', reportObj);
              trackBaseTool.postData(reportObj);
              // SKAPP.onEvent(bindItem.eventName);
            }
          }
        }
      }
    },
    // 判断曝光事件中，是否有元素触发曝光；
    isTrackElement: function () {
      let viewEvents = this.webViewEvents;
      try {
        viewEvents.forEach(item => {
          let ItemXpath = trackBaseTool.decodeXpath(item.xpath);
          let $element = trackBaseTool.getElmByXPath(ItemXpath);
          // let visibility = trackBaseTool.getVisibility($element[0]);
          // info('visibility', visibility);
          if ($element.length > 0 && $element[0]) {
            if (trackBaseTool.getVisibility($element[0])) {
              let data = {
                eventName: item.eventName,
                $EventType$: 'ViewImpression', // 事件类型：曝光事件
                timeStamp: new Date().getTime()
              };
              let bindProperties = item.bindProperties;
              // info('bindProperties===', bindProperties);
              if (bindProperties.length > 0) {
                bindProperties.forEach((propertyItem) => {
                  let proItemXpath = trackBaseTool.decodeXpath(propertyItem.xpath);
                  let propertyEle = trackBaseTool.getElmByXPath(proItemXpath);
                  if (propertyEle[0]) {
                    var content = trackBaseTool.getElementContent(propertyEle[0], propertyEle[0].tagName);
                    data[propertyItem.attributeKey] = content;
                    data[propertyItem.attributeKey + '.$propertyshowname$'] = propertyItem.attributeKeyName;
                  }
                });
              }
              // 埋点上报
              let reportObj = {
                type: 2,
                data: data
              };
              info('元素曝光事件 reportObj==', reportObj);
              trackBaseTool.postData(reportObj);
            }
          }
        });
      } catch (error) {
        info('元素曝光事件 isTrackElement error===', error);
      }
    }
  };
  trackBaseTool.registerAppCallJs(); // 注册app调用js方法【app传递数据给js】
  trackBaseTool.init(); // 注册dom树监听函数
  // info('添加元素点击监听 before =====');
  // trackCollect.init(); // 添加元素点击监听
  handleURLChange(); // 添加url改变监听
  app_h5_define_mode(false); //添加DOM对象树监听，当DOM对象树发生任何变动时，发送元素相关信息；
}();
